
get_arima_resid <- function(x){
  "This function fits and arima model and extracts residuals for a single variable. Not currently used"
  x <- auto.arima(x)
  x <- x$residuals
  return(x)
}

my_var_select <- function(data_frame, .max_lag, ic = "HQ", exogen=NULL, type="const"){
  if(!is.null(exogen)){
    var.select <- VAR(data_frame, type = type, lag.max = .max_lag, ic = ic, exogen = exogen)
    return(var.select)  
  }
  else{
    var.select <- VAR(data_frame, type = type, lag.max = .max_lag, ic = ic)
    return(var.select)
  }
}

df_to_var_select <-function(df, .max_lag, ic ="HQ", exogen = NULL, type="const"){
  "This function pass a dataframe and options to VAR lag selection."
  # for(i in 1:ncol(df)){
  # df[i] <- get_arima_resid(df[i])
  # }
  my_var_select(df, .max_lag = .max_lag , ic = ic, exogen=exogen, type = type)
}


my_var <- function(data_frame, p, exogen=NULL, type="const"){
  if(!is.null(exogen)){
    var <- VAR(data_frame, type = type,  p = p, exogen = exogen)
    return(var)  
  }
  else{
    var <- VAR(data_frame, type = type,  p = p)
    return(var)
  }
}

df_to_var <-function(df, p, exogen=NULL ,type="const"){
  "This function passes a dataframe and options to VAR"
  # for(i in 1:ncol(df)){
  #   df[i] <- get_arima_resid(df[i])
  # }
  my_var(df, p = p, exogen = exogen, type=type)
}


# df_to_arima <-function(df){
#   for(i in 1:ncol(df)){
#     df[i] <- get_arima_resid(df[i])
#   }
#   return(df)
# }

two_way_granger <- function(model, x, y){
  x_cause_y <- causality(model, cause = x)
  y_cause_x <- causality(model, cause = y)
  return(c(x_cause_y, y_cause_x))
}

my_irf <- function(model, impulse, response, ortho=TRUE){
  n = model$p
  irf(model, impulse = impulse, response = response,
      n.ahead = n, ortho = ortho, runs = 100, seed = seed)
}

gg_irf <-function(irf_out, iv, xlab, ylab, p, ymax = 600, ymin = -600){
  x_length <- p +1
  # irf_irf <-irf_out$irf
  ggplot(mapping = aes(
    x=c(1:x_length),
    y = get(iv, irf_out$irf)[,1] )) +
    geom_line() +
    geom_hline(yintercept = 0, lty = 2) +
    geom_ribbon(aes(
      ymin = eval(get(iv, irf_out$Lower))[,1],
      ymax = eval(get(iv, irf_out$Upper))[,1]
    ), alpha = 0.4) +
    labs(x = xlab, y = ylab) +
    coord_cartesian(ylim=c(ymin, ymax), xlim=c(1, p)) +
    scale_x_continuous(breaks = seq(1,p, by =2))
  
  
}


parse_granger <-function(var_out, p, response, iv){
  var_out <- summary(var_out)
  full_result <- var_out$varresult
  response_result <- get(response, full_result)
  response_p_values <- (response_result[4]$coefficients)[,4]
  
  # return(response_p_values)
  
  result_list <- rep(NA, length(response_p_values))
  
  
  
  for(i in 1:length(response_p_values)){
    if(response_p_values[i] < (0.05 / length(response_p_values) )){
      # if(response_p_values[i] < (0.05)){
      result_list[i] <-names(response_p_values[i])
    }
    
  }
  result_list <- na.omit(result_list)
  # result_list <- strsplit(result_list, "\\.")
  result_list<-vapply(strsplit(result_list,"\\."), `[`, 1, FUN.VALUE=character(1))
  result_list <- unique(result_list)
  # return(result_list)
  if(iv %in% result_list){
    return("Yes")
  }
  else{
    return("No")
  }
  # result_list <- length(result_list)
  # for(i in 1:length(result_list)){
  # result_list[i] <- sub('\\..*', '', result_list[i])
  # }
  # result_list <- str_split(result_list, pattern = "\\.")
  # for(i in 1:length(result_list)){
  #   result_list[i] <- result_list[i][1]
  # }
  
}


my_fevd_bar <-function(fevd, response, new_names=NULL){

  plot.data <-data.frame(fevd)
  # names(plot.data)
  if(!is.null(new_names)){ 
    names(plot.data) <- new_names
    }
  # names(plot.data) 
  # nrow(plot.data)
  plot.data <- mutate(plot.data,
                      Day = row_number())
  
  long.data <- pivot_longer(plot.data, cols = !Day, names_to = "variable",
                            values_to = "fedv")
  ggplot(long.data, aes(x=Day, y=fedv, group=variable,
                        fill=variable)) +
    geom_col(position ="dodge") +
    # scale_fill_brewer(palette="OrRd") +
    labs(y=paste0("Proportion of \n",response, " Explained")) +
    theme(legend.title = element_blank(),
          # legend.position = c( .9, .9),
          legend.background = element_blank())  +
    coord_cartesian(ylim = c(0,1))
  
  }


  

# plot_fevd  <-function(x, plot.type = c("multiple", "single"), names = NULL,
#                           main = NULL, col = NULL, ylim = NULL, ylab = NULL, xlab = NULL,
#                           legend = NULL, names.arg = NULL, nc, mar = par("mar"), oma = par("oma"),
#                           addbars = 1, ...){
#   K <- length(x)
#   ynames <- names(x)
#   plot.type <- match.arg(plot.type)
#   if (is.null(names)) {
#     names <- ynames
#   }
#   else {
#     names <- as.character(names)
#     if (!(all(names %in% ynames))) {
#       warning("\nInvalid variable name(s) supplied, using first variable.\n")
#       names <- ynames[1]
#     }
#   }
#   nv <- length(names)
#   #    op <- par(no.readonly = TRUE)
#   ifelse(is.null(main), main <- paste("FEVD for", names), main <- rep(main,
#                                                                       nv)[1:nv])
#   ifelse(is.null(col), col <- gray.colors(K), col <- rep(col,
#                                                          K)[1:K])
#   ifelse(is.null(ylab), ylab <- rep("Percentage", nv), ylab <- rep(ylab,
#                                                                    nv)[1:nv])
#   ifelse(is.null(xlab), xlab <- rep("Horizon", nv), xlab <- rep(xlab,
#                                                                 nv)[1:nv])
#   ifelse(is.null(ylim), ylim <- c(0, 1), ylim <- ylim)
#   ifelse(is.null(legend), legend <- ynames, legend <- legend)
#   if (is.null(names.arg))
#     names.arg <- c(paste(1:nrow(x[[1]])), rep(NA, addbars))
#   plotfevd <- function(x, main, col, ylab, xlab, names.arg,
#                        ylim, ...) {
#     addbars <- as.integer(addbars)
#     if (addbars > 0) {
#       # hmat <- matrix(0, nrow = K, ncol = addbars)
#       # xvalue <- cbind(t(x), hmat)
#       # xvalue <- data.frame(xvalue)
#       data <- data.frame(get(x, ))
#       barplot(xvalue, main = main, col = col, ylab = ylab,
#               xlab = xlab, names.arg = names.arg, ylim = ylim,
#               legend.text = legend, ...)
#       # my_fevd_bar(xvalue, main = main, col = col, ylab = ylab,
#                   # xlab = xlab, names.arg = names.arg, ylim = ylim,
#                   # ...)
#       abline(h = 0)
#     }
#     else {
#       xvalue <- t(x)
#       xvalue <- data.frame(xvalue)
#       # barplot(xvalue, main = main, col = col, ylab = ylab,
#               # xlab = xlab, names.arg = names.arg, ylim = ylim,
#               # ...)
#       my_fevd_bar(xvalue, main = main, col = col, ylab = ylab,
#                   xlab = xlab, names.arg = names.arg, ylim = ylim,
#                   ...)
#       # abline(h = 0)
#     }
#   }
#   if (plot.type == "single") {
#     #        par(mar = mar, oma = oma)
#     #        if (nv > 1)
#     #            par(ask = TRUE)
#     for (i in 1:nv) {
#       plotfevd(x = x[[names[i]]], main = main[i], col = col,
#                ylab = ylab[i], xlab = xlab[i], names.arg = names.arg,
#                ylim = ylim, ...)
#     }
#   }
#   else if (plot.type == "multiple") {
#     if (missing(nc)) {
#       nc <- ifelse(nv > 4, 2, 1)
#     }
#     nr <- ceiling(nv/nc)
#     par(mfcol = c(nr, nc), mar = mar, oma = oma)
#     for (i in 1:nv) {
#       plotfevd(x = x[[names[i]]], main = main[i], col = col,
#                ylab = ylab[i], xlab = xlab[i], names.arg = names.arg,
#                ylim = ylim, ...)
#     }
#   }
#   #    on.exit(par(op))
# }

