from google.cloud import bigquery
import math
import sys
import numpy as np
from scipy.stats import t
import pandas as pd
# import custom functions

client = bigquery.Client()

# results_path = '../../data/'
        
results_path = '../data/'


def get_sum_stats(data, variables):
    query = "SELECT "
#     counter = 0
    for x in variables:
#         if counter > 0:
#             query += ","
        query += "AVG("+x+") as mean_"+x+",  MIN("+x+") as min_"+x+", MAX("+x+") as max_"+x+", STDDEV_SAMP("+x+") as stddev_"+x+","
#         counter += 1
    query += "FROM `"+data+"`"
    query_job = client.query(query)
    result = query_job.result().to_dataframe()
    return(result)
#     print(query)
#     return(query)

    
# Provide data and model info

post_data = 'bigquery-226322.bq_catching_fire.post_level'

network_data = 'bigquery-226322.bq_catching_fire.user_level'



post_vars = ["national_humiliation", "combined_force", "territory", "trade_barrier", "aiguo", "income_ineq", "content_length",
            "mid", "articles"]


post_sumstats = get_sum_stats(data = post_data, variables = post_vars)

post_sumstats.to_csv(results_path + "post_sumstats.csv", index=False)

network_vars = ["national_humiliation", "aiguo", "income_ineq", "content_length",
               "f_national_humiliation", "f_force", "f_territory", "f_trade_barrier", "f_income_ineq", "num_p_followers",
               "mid", "user_ppd", "articles"]

network_sumstats = get_sum_stats(data = network_data, variables = network_vars)

network_sumstats.to_csv(results_path + "network_sumstats.csv", index=False)